repeats = 3

def run(fn):
    print 'Reading data set %s...' % fn
    f = file(fn)
    ints = [l.strip() for l in f.readlines()]
    avglen = float(sum([len(l) for l in ints])) / len(ints)

    print 'Running conversion...'
    
    import time
    
    looptime = 1000.0
    for i in xrange(repeats):
	t0 = time.time()
	for x in ints:
	    x = x
		
	looptime = min(time.time() - t0, looptime)
    
    print 'bare loop: %.3f, best of %d' % (looptime, repeats)
    
    longtime = 1000.0
    for i in xrange(repeats):
	t0 = time.time()
	for x in ints:
	    x = long(x)
	
	longtime = min(time.time() - t0, longtime)
	
    adjlong = longtime - looptime
    print 'long(): %.3f, best of %d (%.3f before removing bare loop time)' % (adjlong, repeats, longtime)

    return (avglen, looptime, looptime / len(ints), adjlong, adjlong/len(ints))

if __name__ == '__main__':
    import csv, time, os
    wdir = os.path.dirname(__file__)

    f = csv.writer(file(time.strftime('%Y%m%d-%H%M%S-convert.csv'), 'wb'))
    f.writerow(('Data set', 'Avg len', 'Bare loop', 'Bare (usec/#)', 'long()', 'long (usec/#)'))

    n = 1
    while 1:
        fn = os.path.join(wdir, 'longtest%02d.txt' % n)
        if not os.path.exists(fn):
            break
        print '-'*30
        f.writerow((n, )+run(fn))
        n += 1

